const {red} = require('chalk');
const path = require('path');
const createRollupConfig = require('../config/rollup.config.default');
const rollup = require('rollup');

const build = async function(
  dir = process.cwd(),
  {minify = false, outputDir, mashup, basePath}
) {
  outputDir = outputDir || path.join(dir, 'dist');
  const config = await createRollupConfig({
    dir,
    minify,
    outputDir,
    basePath,
    target: mashup ? 'mashup' : undefined
  });
  const bundle = await rollup.rollup(config);
  await bundle.write(config.output);
};

module.exports = async (...args) => {
  try {
    await build(...args);
  } catch (err) {
    console.error(red(err));
    console.error(err.stack);
    process.exit(-1);
  }
};
