const {green, yellow, red} = require('chalk');
const fileSize = require('filesize');
const gzipSize = require('gzip-size');
const terser = require('terser');

module.exports = function chunkInfo() {
  return {
    name: 'chunk-info',
    generateBundle: async function(outputOptions, bundle) {
      for (const chunkName of Object.keys(bundle)) {
        const {code} = bundle[chunkName];
        const size = fileSize(Buffer.byteLength(code));
        const sizeGzipped = fileSize(await gzipSize(code));

        console.log(
          ` > ${yellow(chunkName)}: ${green(size)} (${green(
            sizeGzipped
          )} gzipped)`
        );

        // might be a bad idea to minify on every bundling
        // const sizeGzippedMinified = fileSize(await gzipSize(terser.minify(code).code));
        // console.log(` > ${yellow(chunkName)}: ${green(size)} (${green(sizeGzipped)} gzipped, ${green(sizeGzippedMinified)} minified)`)
      }
    }
  };
};
