const rimraf = require('rimraf');
const path = require('path');

const isSubdir = (dir, parent) => {
  const relative = path.relative(parent, dir);
  return !!relative && !relative.startsWith('..') && !path.isAbsolute(relative);
};

module.exports = function clean({inputDir}) {
  return {
    generateBundle: async function(outputOptions, bundle, isWrite) {
      if (isWrite) {
        const {dir} = outputOptions;
        if (isSubdir(__dirname, dir)) {
          throw new Error(`cleaning ${dir} would remove this plugin, aborting`);
        }
        if (!isSubdir(dir, inputDir)) {
          throw new Error(`${dir} is not a subdirectory of input ${inputDir}`);
        }
        return new Promise(resolve => rimraf(dir, resolve));
      }
    }
  };
};
