export async function initialize() {
  const {loadChunk1, loadChunk2} = await import('./arbitaryFolder/chunk');
  await loadChunk1();
  // manually import second chunk before arbitary folder chunk has a chance to load it
  await import('./chunk2');
  // at this point, arbitary folder chunk will try to load chunk 2, but it will be taken
  // from the loaded chunks object immediately
  await loadChunk2();
  // once all chunks are loaded, no other requests will come out, and their promises will
  // be resolved immediately
  await import('./chunk1');
  await import('./chunk2');
  window.tau.initChunksLoaded();
  // chunk 3 will only be loaded when window.loadLastChunk is called
  // it also intentionally has a clashing name - we already have a file
  // named 'chunk' in arbitaryFolder
  window.tau.loadLastChunk = async () => await import('./chunk');
}
